# aMule Stats in irssi.. v0.1
# just put it to ~/.irssi/scripts and check /amule help ;)
###########

use Irssi;
use vars qw($VERSION %IRSSI);
use strict;

$VERSION = '0.1';
%IRSSI = (
  authors     => 'ak',
  contact     => 'ocb23@freenet.de',
  name        => 'aMule stats',
  description => 'Brings aMule stats into Irssi, either as echo or to channel/nick',
  license     => 'Public Domain',
  url         => 'http://members.tripod.com.br/archiv/',
  changed     => '2003/12/29',
);

sub cmd_amule {
	my ($args, $server, $target) = @_;
	my (@aarray, @out, $sig);
	$args =~ s/\s+$//;
	$sig=Irssi::settings_get_str('amule_amulesig');
	open amule, $sig;
	if(!<amule>) {
		Irssi::print "Please /set amule_amulesig to the path of your amulesig.dat";
		Irssi::print "Also, your must enable the option Online Signature in your aMule Settings";
		Irssi::print "And don't use ~ or \$HOME in the path, use /home/foobar/.aMule/amulesig.dat";
		return
	}
	while(<amule>) {
		$_ =~ s/\n//;
		push(@aarray, $_);
	}
	close amule;
	push(@out, ".---------- aMule ".@aarray[11]." Stats -----------");
	push(@out, "| Server: ".@aarray[0]." (".$aarray[1].":".@aarray[2].")");
	push(@out, "| Speed: ".@aarray[4]." kb/s down, ".@aarray[5]." kb/s up");
	push(@out, "| Transferred: ".@aarray[9]." GB down, ".@aarray[10]." GB up");
	push(@out, "`------ Files: ".@aarray[7]." Queue: ".@aarray[6]." ID: ".@aarray[3]." -------->");

	if (!$args) {
		foreach(@out) {
			Irssi::active_win->print("$_");
		}
		return;
	}
	for ($args) { 
		if (/help/) {
			Irssi::print("Usage: /amule [target]\n".
			" If no target is given, the stats appear as local echo.");
		}
		else {
			foreach(@out) {
				$server->command("msg $args $_");
			}
		}
	}
}

Irssi::settings_add_str('amule', 'amule_amulesig', "/full_path_to_home/.aMule/amulesig.dat");
Irssi::command_bind('amule', 'cmd_amule');
Irssi::command_bind('amule help', 'cmd_amule');

#EOF
